//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Mainly designed and written by Andr Slabber. No Rights Reserved...  Parts by others...
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  File:         SLabelDlg.cpp
//  Module:       Diary
//  Author:       Andr Slabber
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Description:  Implementation of Class SLabelDlg.
//
//////////////////////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "diary.h"
#include "diarydlg.h"
#include "toolkit.h"
#include "SLabelDlg.h"
#include "monitors.h"
#include "multimonitor.h"
#include "monitordc.h"
#include "todolist.h"

// SLabelDlg dialog

IMPLEMENT_DYNAMIC(SLabelDlg, CDialog)
SLabelDlg::SLabelDlg(CWnd* pParent /*=NULL*/)
	: CDialog(SLabelDlg::IDD, pParent),
	  mShortcut1(0),
	  mShortcut2(0),
	  mShortcut3(0),
	  mShortcut4(0),
	  mShortcut5(0),
	  mShortcut6(0),
	  mShortcut7(0),
	  mShortcut8(0),
	  mShortcut9(0),
	  mShortcut10(0),
	  mShortcut11(0),
	  mShortcut12(0),
	  mShortcut13(0),
	  mShortcut14(0),
	  mShortcut15(0),
	  mShortcut16(0),
	  mTodoList0(0),
	  mTodoList1(0),
	  mTodoList2(0),
	  mTodoList3(0),
	  mTodoList4(0),
	  mTodoList5(0),
	  mTodoList6(0),
	  mTodoList7(0),
	  mTodoList8(0),
	  mTodoList9(0),
	  mTodoList10(0),
	  mTodoList11(0),
	  mTodoList12(0)
{
}

SLabelDlg::~SLabelDlg()
{
	if (mShortcut1) delete mShortcut1;
	if (mShortcut2) delete mShortcut2;
	if (mShortcut3) delete mShortcut3;
	if (mShortcut4) delete mShortcut4;
	if (mShortcut5) delete mShortcut5;
	if (mShortcut6) delete mShortcut6;
	if (mShortcut7) delete mShortcut7;
	if (mShortcut8) delete mShortcut8;
	if (mShortcut9) delete mShortcut9;
	if (mShortcut10) delete mShortcut10;
	if (mShortcut11) delete mShortcut11;
	if (mShortcut12) delete mShortcut12;
	if (mShortcut13) delete mShortcut13;
	if (mShortcut14) delete mShortcut14;
	if (mShortcut15) delete mShortcut15;
	if (mShortcut16) delete mShortcut16;

	if (mTodoList0) delete mTodoList0;
	if (mTodoList1) delete mTodoList1;
	if (mTodoList2) delete mTodoList2;
	if (mTodoList3) delete mTodoList3;
	if (mTodoList4) delete mTodoList4;
	if (mTodoList5) delete mTodoList5;
	if (mTodoList6) delete mTodoList6;
	if (mTodoList7) delete mTodoList7;
	if (mTodoList8) delete mTodoList8;
	if (mTodoList9) delete mTodoList9;
	if (mTodoList10) delete mTodoList10;
	if (mTodoList11) delete mTodoList11;
	if (mTodoList12) delete mTodoList12;
}

void SLabelDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(SLabelDlg, CDialog)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_BN_CLICKED(ID_CLEARALL, OnBnClickedClearall)
END_MESSAGE_MAP()

BOOL SLabelDlg::OnInitDialog(void)
{
   BOOL lRetCode = CDialog::OnInitDialog();

   TK_LOG0("Read the position settings and restore them");
   SSetting *lSettingTop    = SDiaryDlg::Instance()
                                 ->GetSettings()->GetSetting(SET_LABEL_TOP);
   SSetting *lSettingLeft   = SDiaryDlg::Instance()
                                 ->GetSettings()->GetSetting(SET_LABEL_LEFT);

   if (lSettingTop  != NULL &&
       lSettingLeft != NULL)
   {
      TK_LOG0("Position settings found, positioning window");

      int lTop  = lSettingTop->GetValueAsNumber();
      int lLeft = lSettingLeft->GetValueAsNumber();

	  // make sure it will be on-screen, but keep the original position in config
	  this->SetWindowPos(0, lLeft, lTop, 0, 0, SWP_NOSIZE);
	  if (CMonitors::IsOnScreen( this ) == false)
	  {
		  CMonitor thePrimary = CMonitors::GetPrimaryMonitor();
		  thePrimary.CenterWindowToMonitor(this, true);
		  mWindowCentered = true;
          WINDOWPLACEMENT lWinPlace;
          this->GetWindowPlacement(&lWinPlace);
          mTop = lWinPlace.rcNormalPosition.top;
          mLeft = lWinPlace.rcNormalPosition.left;
	  }
   }

	mShortcut1->Couple(IDC_EDIT_LBL1, IDC_LBL_CHECK1, IDC_EDIT_WORDS1);
	mShortcut2->Couple(IDC_EDIT_LBL2, IDC_LBL_CHECK2, IDC_EDIT_WORDS2);
	mShortcut3->Couple(IDC_EDIT_LBL3, IDC_LBL_CHECK3, IDC_EDIT_WORDS3);
	mShortcut4->Couple(IDC_EDIT_LBL4, IDC_LBL_CHECK4, IDC_EDIT_WORDS4);
	mShortcut5->Couple(IDC_EDIT_LBL5, IDC_LBL_CHECK5, IDC_EDIT_WORDS5);
	mShortcut6->Couple(IDC_EDIT_LBL6, IDC_LBL_CHECK6, IDC_EDIT_WORDS6);
	mShortcut7->Couple(IDC_EDIT_LBL7, IDC_LBL_CHECK7, IDC_EDIT_WORDS7);
	mShortcut8->Couple(IDC_EDIT_LBL8, IDC_LBL_CHECK8, IDC_EDIT_WORDS8);
	mShortcut9->Couple(IDC_EDIT_LBL9, IDC_LBL_CHECK9, IDC_EDIT_WORDS9);
	mShortcut10->Couple(IDC_EDIT_LBL10, IDC_LBL_CHECK10, IDC_EDIT_WORDS10);
	mShortcut11->Couple(IDC_EDIT_LBL11, IDC_LBL_CHECK11, IDC_EDIT_WORDS11);
	mShortcut12->Couple(IDC_EDIT_LBL12, IDC_LBL_CHECK12, IDC_EDIT_WORDS12);
	mShortcut13->Couple(IDC_EDIT_LBL13, IDC_LBL_CHECK13, IDC_EDIT_WORDS13);
	mShortcut14->Couple(IDC_EDIT_LBL14, IDC_LBL_CHECK14, IDC_EDIT_WORDS14);
	mShortcut15->Couple(IDC_EDIT_LBL15, IDC_LBL_CHECK15, IDC_EDIT_WORDS15);
	mShortcut16->Couple(IDC_EDIT_LBL16, IDC_LBL_CHECK16, IDC_EDIT_WORDS16);

    // couple in todolists
    mTodoList1->Couple(IDC_EDIT_TODO1);
    mTodoList2->Couple(IDC_EDIT_TODO2);
    mTodoList3->Couple(IDC_EDIT_TODO3);
    mTodoList4->Couple(IDC_EDIT_TODO4);
    mTodoList5->Couple(IDC_EDIT_TODO5);
    mTodoList6->Couple(IDC_EDIT_TODO6);
    mTodoList7->Couple(IDC_EDIT_TODO7);
    mTodoList8->Couple(IDC_EDIT_TODO8);
    mTodoList9->Couple(IDC_EDIT_TODO9);
    mTodoList10->Couple(IDC_EDIT_TODO10);
    mTodoList11->Couple(IDC_EDIT_TODO11);
    mTodoList12->Couple(IDC_EDIT_TODO12);

    mTodoList1->SettingsToDialog();
    mTodoList2->SettingsToDialog();
    mTodoList3->SettingsToDialog();
    mTodoList4->SettingsToDialog();
    mTodoList5->SettingsToDialog();
    mTodoList6->SettingsToDialog();
    mTodoList7->SettingsToDialog();
    mTodoList8->SettingsToDialog();
    mTodoList9->SettingsToDialog();
    mTodoList10->SettingsToDialog();
    mTodoList11->SettingsToDialog();
    mTodoList12->SettingsToDialog();

	mShortcut1->SettingsToDialog();
	mShortcut2->SettingsToDialog();
	mShortcut3->SettingsToDialog();
	mShortcut4->SettingsToDialog();
	mShortcut5->SettingsToDialog();
	mShortcut6->SettingsToDialog();
	mShortcut7->SettingsToDialog();
	mShortcut8->SettingsToDialog();
	mShortcut9->SettingsToDialog();
	mShortcut10->SettingsToDialog();
	mShortcut11->SettingsToDialog();
	mShortcut12->SettingsToDialog();
	mShortcut13->SettingsToDialog();
	mShortcut14->SettingsToDialog();
	mShortcut15->SettingsToDialog();
	mShortcut16->SettingsToDialog();

    char  *lTitle = new char[MAX_STRING];
    char  *lCurDir = new char[MAX_STRING];
    GetCurrentDirectory(MAX_STRING, lCurDir);
    sprintf_s(lTitle, MAX_STRING - 1,  
              "%s - Configuration", 
              lCurDir);
    TK_LOG1("Set Window title to %s", lTitle);
    SetWindowText(lTitle);

	delete [] lTitle;
	delete [] lCurDir;
	return lRetCode;
}

void SLabelDlg::SavePosition(void)
{
   TK_LOG0("Save window position to settings.dat");
   WINDOWPLACEMENT lWinPlace;
   this->GetWindowPlacement(&lWinPlace);

   // cancel save if window centered, and not moved yet...
   if (mWindowCentered == true &&
	   (mTop == lWinPlace.rcNormalPosition.top ||
	    mLeft == lWinPlace.rcNormalPosition.left))
   {
	   return;
   }

   // ok, we save so set the flag to off
   mWindowCentered = false;
   mTop = -1;
   mLeft = -1;

   TK_LOG0("Get the Top position value");
   char *lTop = new char[MAX_STRING];
   _itoa_s(lWinPlace.rcNormalPosition.top, lTop, MAX_STRING - 1, 10);
   SSetting *lTopSSetting = new SSetting(SET_LABEL_TOP, lTop);
   SDiaryDlg::Instance()->GetSettings()->AddSetting(lTopSSetting);
   delete [] lTop;
 
   TK_LOG0("Get the Left position value");
   char *lLeft = new char[MAX_STRING];
   _itoa_s(lWinPlace.rcNormalPosition.left, lLeft, MAX_STRING - 1, 10);
   SSetting *lLeftSSetting = new SSetting(SET_LABEL_LEFT, lLeft);
   SDiaryDlg::Instance()->GetSettings()->AddSetting(lLeftSSetting);
   delete [] lLeft;

   TK_LOG0("Make sure the settings are flushed to disk");
   SDiaryDlg::Instance()->GetSettings()->WriteFile();
}

void SLabelDlg::OnBnClickedOk()
{
	this->SavePosition();

	mShortcut1->DialogToSettings(false);
	mShortcut2->DialogToSettings(false);
	mShortcut3->DialogToSettings(false);
	mShortcut4->DialogToSettings(false);
	mShortcut5->DialogToSettings(false);
	mShortcut6->DialogToSettings(false);
	mShortcut7->DialogToSettings(false);
	mShortcut8->DialogToSettings(false);
	mShortcut9->DialogToSettings(false);
	mShortcut10->DialogToSettings(false);
	mShortcut11->DialogToSettings(false);
	mShortcut12->DialogToSettings(false);
	mShortcut13->DialogToSettings(false);
	mShortcut14->DialogToSettings(false);
	mShortcut15->DialogToSettings(false);
	mShortcut16->DialogToSettings(false);

	mTodoList1->DialogToSettings(false);
	mTodoList2->DialogToSettings(false);
	mTodoList3->DialogToSettings(false);
	mTodoList4->DialogToSettings(false);
	mTodoList5->DialogToSettings(false);
	mTodoList6->DialogToSettings(false);
	mTodoList7->DialogToSettings(false);
	mTodoList8->DialogToSettings(false);
	mTodoList9->DialogToSettings(false);
	mTodoList10->DialogToSettings(false);
	mTodoList11->DialogToSettings(false);
	mTodoList12->DialogToSettings(true);

	OnOK();
}

void SLabelDlg::OnBnClickedCancel()
{
	this->SavePosition();

	mShortcut1->SettingsToDialog();
	mShortcut2->SettingsToDialog();
	mShortcut3->SettingsToDialog();
	mShortcut4->SettingsToDialog();
	mShortcut5->SettingsToDialog();
	mShortcut6->SettingsToDialog();
	mShortcut7->SettingsToDialog();
	mShortcut8->SettingsToDialog();
	mShortcut9->SettingsToDialog();
	mShortcut10->SettingsToDialog();
	mShortcut11->SettingsToDialog();
	mShortcut12->SettingsToDialog();
	mShortcut13->SettingsToDialog();
	mShortcut14->SettingsToDialog();
	mShortcut15->SettingsToDialog();
	mShortcut16->SettingsToDialog();

	OnCancel();
}

STodoList *SLabelDlg::GetTodoList(int theNumber)
{
	switch (theNumber)
	{
	case 0:		return mTodoList0;
	case 1:		return mTodoList1;
	case 2:		return mTodoList2;
	case 3:		return mTodoList3;
	case 4:		return mTodoList4;
	case 5:		return mTodoList5;
	case 6:		return mTodoList6;
	case 7:		return mTodoList7;
	case 8:		return mTodoList8;
	case 9:		return mTodoList9;
	case 10:    return mTodoList10;
	case 11:	return mTodoList11;
	case 12:	return mTodoList12;
	}

	return 0;
}

SShortcut *SLabelDlg::GetLabel(int theNumber)
{
	switch (theNumber)
	{
	case 1:		return mShortcut1;
	case 2:		return mShortcut2;
	case 3:		return mShortcut3;
	case 4:		return mShortcut4;
	case 5:		return mShortcut5;
	case 6:		return mShortcut6;
	case 7:		return mShortcut7;
	case 8:		return mShortcut8;
	case 9:		return mShortcut9;
	case 10:	return mShortcut10;
	case 11:	return mShortcut11;
	case 12:	return mShortcut12;
	case 13:	return mShortcut13;
	case 14:	return mShortcut14;
	case 15:	return mShortcut15;
	case 16:	return mShortcut16;
	}

	return 0;
}

void SLabelDlg::SetDiaryDlg(void)
{
	if (mShortcut1 == 0) mShortcut1 = new SShortcut(this, 1);
	if (mShortcut2 == 0) mShortcut2 = new SShortcut(this, 2);
	if (mShortcut3 == 0) mShortcut3 = new SShortcut(this, 3);
	if (mShortcut4 == 0) mShortcut4 = new SShortcut(this, 4);
	if (mShortcut5 == 0) mShortcut5 = new SShortcut(this, 5);
	if (mShortcut6 == 0) mShortcut6 = new SShortcut(this, 6);
	if (mShortcut7 == 0) mShortcut7 = new SShortcut(this, 7);
	if (mShortcut8 == 0) mShortcut8 = new SShortcut(this, 8);
	if (mShortcut9 == 0) mShortcut9 = new SShortcut(this, 9);
	if (mShortcut10 == 0) mShortcut10 = new SShortcut(this, 10);
	if (mShortcut11 == 0) mShortcut11 = new SShortcut(this, 11);
	if (mShortcut12 == 0) mShortcut12 = new SShortcut(this, 12);
	if (mShortcut13 == 0) mShortcut13 = new SShortcut(this, 13);
	if (mShortcut14 == 0) mShortcut14 = new SShortcut(this, 14);
	if (mShortcut15 == 0) mShortcut15 = new SShortcut(this, 15);
	if (mShortcut16 == 0) mShortcut16 = new SShortcut(this, 16);

	mShortcut1->ReadFromSettings();
	mShortcut2->ReadFromSettings();
	mShortcut3->ReadFromSettings();
	mShortcut4->ReadFromSettings();
	mShortcut5->ReadFromSettings();
	mShortcut6->ReadFromSettings();
	mShortcut7->ReadFromSettings();
	mShortcut8->ReadFromSettings();
	mShortcut9->ReadFromSettings();
	mShortcut10->ReadFromSettings();
	mShortcut11->ReadFromSettings();
	mShortcut12->ReadFromSettings();
	mShortcut13->ReadFromSettings();
	mShortcut14->ReadFromSettings();
	mShortcut15->ReadFromSettings();
	mShortcut16->ReadFromSettings();

	mShortcut1->Revert();
	mShortcut2->Revert();
	mShortcut3->Revert();
	mShortcut4->Revert();
	mShortcut5->Revert();
	mShortcut6->Revert();
	mShortcut7->Revert();
	mShortcut8->Revert();
	mShortcut9->Revert();
	mShortcut10->Revert();
	mShortcut11->Revert();
	mShortcut12->Revert();
	mShortcut13->Revert();
	mShortcut14->Revert();
	mShortcut15->Revert();
	mShortcut16->Revert();

	if (mTodoList0 == 0) mTodoList0 = new STodoList(0, SDiaryDlg::Instance(), this);
	if (mTodoList1 == 0) mTodoList1 = new STodoList(1, SDiaryDlg::Instance(), this);
	if (mTodoList2 == 0) mTodoList2 = new STodoList(2, SDiaryDlg::Instance(), this);
	if (mTodoList3 == 0) mTodoList3 = new STodoList(3, SDiaryDlg::Instance(), this);
	if (mTodoList4 == 0) mTodoList4 = new STodoList(4, SDiaryDlg::Instance(), this);
	if (mTodoList5 == 0) mTodoList5 = new STodoList(5, SDiaryDlg::Instance(), this);
	if (mTodoList6 == 0) mTodoList6 = new STodoList(6, SDiaryDlg::Instance(), this);
	if (mTodoList7 == 0) mTodoList7 = new STodoList(7, SDiaryDlg::Instance(), this);
	if (mTodoList8 == 0) mTodoList8 = new STodoList(8, SDiaryDlg::Instance(), this);
	if (mTodoList9 == 0) mTodoList9 = new STodoList(9, SDiaryDlg::Instance(), this);
	if (mTodoList10 == 0) mTodoList10 = new STodoList(10, SDiaryDlg::Instance(), this);
	if (mTodoList11 == 0) mTodoList11 = new STodoList(11, SDiaryDlg::Instance(), this);
	if (mTodoList12 == 0) mTodoList12 = new STodoList(12, SDiaryDlg::Instance(), this);

	mTodoList0->ReadFromSettings();
	mTodoList1->ReadFromSettings();
	mTodoList2->ReadFromSettings();
	mTodoList3->ReadFromSettings();
	mTodoList4->ReadFromSettings();
	mTodoList5->ReadFromSettings();
	mTodoList6->ReadFromSettings();
	mTodoList7->ReadFromSettings();
	mTodoList8->ReadFromSettings();
	mTodoList9->ReadFromSettings();
	mTodoList10->ReadFromSettings();
	mTodoList11->ReadFromSettings();
	mTodoList12->ReadFromSettings();

	mTodoList0->Revert();
	mTodoList1->Revert();
	mTodoList2->Revert();
	mTodoList3->Revert();
	mTodoList4->Revert();
	mTodoList5->Revert();
	mTodoList6->Revert();
	mTodoList7->Revert();
	mTodoList8->Revert();
	mTodoList9->Revert();
	mTodoList10->Revert();
	mTodoList11->Revert();
	mTodoList12->Revert();
}

void SLabelDlg::OnBnClickedClearall()
{
   CString lMsg = "Do you really want to\nclear all label settings?";
   if (MessageBox(lMsg, "Clear Settings", MB_YESNO) == IDYES)
   {
       TK_LOG0("Clear Settings Confirmed");

		mShortcut1->Clear();
		mShortcut2->Clear();
		mShortcut3->Clear();
		mShortcut4->Clear();
		mShortcut5->Clear();
		mShortcut6->Clear();
		mShortcut7->Clear();
		mShortcut8->Clear();
		mShortcut9->Clear();
		mShortcut10->Clear();
		mShortcut11->Clear();
		mShortcut12->Clear();
		mShortcut13->Clear();
		mShortcut14->Clear();
		mShortcut15->Clear();
		mShortcut16->Clear();
   }
}

