//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Mainly designed and written by Andr Slabber. No Rights Reserved...  Parts by others...
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  File:         SLabelDlg.h
//  Module:       Diary
//  Author:       Andr Slabber
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Description:  Declaration of Class SLabelDlg.
//
//////////////////////////////////////////////////////////////////////////////////////////////
#ifndef LABELDLG_H_INCLUDED
#define LABELDLG_H_INCLUDED

#include "diary.h"
#include "SShortcut.h"

class STodoList;
class SDiaryDlg;

//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Class SLabelDlg
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Description:  SLabelDlg handles the various controls in the settings dialog. This is non-
//                resizeable, because it does not need to be. 
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Date		Name                  Comments
//	20080921	Andr Slabber         Created
//
//////////////////////////////////////////////////////////////////////////////////////////////
class SLabelDlg : public CDialog
{
	DECLARE_DYNAMIC(SLabelDlg)

public:
	SLabelDlg(CWnd* pParent = NULL);   // standard constructor
	virtual ~SLabelDlg();

    void SavePosition(void);
	void SetDiaryDlg(void);
	SShortcut *GetLabel(int theNumber);

// Dialog Data
	enum { IDD = IDD_LABEL_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

private:
	SShortcut   *mShortcut1;
	SShortcut   *mShortcut2;
	SShortcut   *mShortcut3;
	SShortcut   *mShortcut4;
	SShortcut   *mShortcut5;
	SShortcut   *mShortcut6;
	SShortcut   *mShortcut7;
	SShortcut   *mShortcut8;
	SShortcut   *mShortcut9;
	SShortcut   *mShortcut10;
	SShortcut   *mShortcut11;
	SShortcut   *mShortcut12;
	SShortcut   *mShortcut13;
	SShortcut   *mShortcut14;
	SShortcut   *mShortcut15;
	SShortcut   *mShortcut16;

    // stuff to correctly reposition if offscreen
    bool mWindowCentered;
    int  mTop;
    int  mLeft;

protected:
	DECLARE_MESSAGE_MAP()

public:
    STodoList *mTodoList0;
    STodoList *mTodoList1;
    STodoList *mTodoList2;
    STodoList *mTodoList3;
    STodoList *mTodoList4;
    STodoList *mTodoList5;
    STodoList *mTodoList6;
    STodoList *mTodoList7;
    STodoList *mTodoList8;
    STodoList *mTodoList9;
    STodoList *mTodoList10;
    STodoList *mTodoList11;
    STodoList *mTodoList12;

	STodoList *GetDefaultTodoList() { return mTodoList0; };
	STodoList *GetTodoList(int pNum);

    virtual BOOL OnInitDialog(void);
	afx_msg void OnBnClickedOk();
	afx_msg void OnBnClickedCancel();
	afx_msg void OnEnMaxtextEditLbl1();
	afx_msg void OnBnClickedClearall();
};

#endif