//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Mainly designed and written by Andr Slabber. No Rights Reserved...  Parts by others...
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  File:         TodoList.h
//  Module:       Diary
//  Author:       Andr Slabber
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Description:  Declaration of Class TodoList.
//
//////////////////////////////////////////////////////////////////////////////////////////////
#ifndef STODOLIST_H_INCLUDED
#define STODOLIST_H_INCLUDED

#include "stdafx.h"
#include <string>
#include "diaryDlg.h"

//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Class STodoList
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//  Description:  STodoList is the object meant to store the info behind the various Todolists. 
//                It couples the TodoList settings in the settings dialog to the relevant 
//                controls on the main window. 
//
//////////////////////////////////////////////////////////////////////////////////////////////
//
//	Date		Name                  Comments
//	20080921	Andr Slabber         Created
//
//////////////////////////////////////////////////////////////////////////////////////////////
class STodoList
{
public:
	STodoList(int pSlotNumber, SDiaryDlg *theDiaryDlg, SLabelDlg *pLabelDlg );
	virtual ~STodoList();

	void SetName(CString &pName);
	void Couple(int pLabelTextControl);
	void ReadFromSettings();
	void WriteToSettings(bool WriteFile);
	void Clear();
	void Revert();
	void Apply();
	void ReadFromDialog();
	void SetOnDialog();
	void SettingsToDialog();
	void DialogToSettings(bool WriteFile);
	void AddToCombo(CComboBox *theBox);
	std::string GetName(bool ellipsis);
	void Load();
	bool Save();

protected:

private:
    SLabelDlg *mLabelDlg;
	std::string mName;
	std::string mFullText;
	int mNameControl;
	int mSlotNumber;
	SSetting *mNameSetting;
};

#endif // STODOLIST_H_INCLUDED