// UpdateDialog.cpp : implementation file
//

#include "stdafx.h"
#include "diary.h"
#include "diarydlg.h"
#include "toolkit.h"
#include "UpdateDialog.h"
#include "settingsfile.h"

// CUpdateDialog dialog

IMPLEMENT_DYNAMIC(CUpdateDialog, CDialog)

CUpdateDialog::CUpdateDialog(CWnd* pParent /*=NULL*/)
	: CDialog(CUpdateDialog::IDD, pParent)
{

}

CUpdateDialog::~CUpdateDialog()
{
}

void CUpdateDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_ALWAYS_THIS_ANSWER, mAlwaysAnswer);
}

BOOL CUpdateDialog::OnInitDialog(void)
{
   TK_TRACER("CUpdateDialog::OnInitDialog(void)");

   BOOL lResult = CDialog::OnInitDialog();

   TK_LOG0("Set the version numbers on the first line of the dialog");
   CString lString;
   std::string lAvailable = ::GetAvailableVersionNumber();
   lAvailable[4] = '\0';
   
   lString.Format("Diary %s is now available", lAvailable.c_str());

   this->GetDlgItem(IDC_AVAILABLE)->SetWindowText(lString.GetBuffer());

   SSetting *lSettingAnswer = SDiaryDlg::Instance()->GetSettings()->GetSetting(SET_UPGRADE_ANSWER);

   std::string lAnswer = "";
   if (lSettingAnswer != NULL)
   {
      TK_LOG0("Position settings found, positioning window");
	  lAnswer  = lSettingAnswer->GetValue();
	  if (lAnswer == "Yes")
	  {
		  OnOK();
	  }
	  else if (lAnswer == "No")
	  {
		  OnCancel();
	  }
   }

   return lResult;
}


BEGIN_MESSAGE_MAP(CUpdateDialog, CDialog)
	ON_BN_CLICKED(IDOK, &CUpdateDialog::OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, &CUpdateDialog::OnBnClickedCancel)
END_MESSAGE_MAP()


// CUpdateDialog message handlers

void CUpdateDialog::OnBnClickedOk()
{
	// if UseAnswerAlways checked, store setting....
	if (mAlwaysAnswer.GetCheck() != 0)
	{
        SSetting *lNewSSettingObject = new SSetting(SET_UPGRADE_ANSWER, "Yes");
        SDiaryDlg::Instance()->GetSettings()->AddSetting(lNewSSettingObject);
        SDiaryDlg::Instance()->GetSettings()->WriteFile();
	}
    
	OnOK();
}

void CUpdateDialog::OnBnClickedCancel()
{
	// if UseAnswerAlways checked, store setting....
	if (mAlwaysAnswer.GetCheck() != 0)
	{
        SSetting *lNewSSettingObject = new SSetting(SET_UPGRADE_ANSWER, "No");
		SDiaryDlg::Instance()->GetSettings()->AddSetting(lNewSSettingObject);
        SDiaryDlg::Instance()->GetSettings()->WriteFile();
	}
    
	OnCancel();
}
