#include "stdafx.h"
#include "toolkit.h"

Tracer::Tracer(char *pName)
{
   mName = pName;
   Logger::Log(MT_TRACING, _FILE_, __LINE__, RC_OK, ">>> %s", (char *)mName);
   Logger::Indent();
#ifdef TOOLKIT_TIMING
   mTimer.startTimer(mName);
#endif
}

Tracer::~Tracer(void)
{
#ifdef TOOLKIT_TIMING
   mTimer.stopTimer();
#endif
   Logger::Undent();
   Logger::Log(MT_TRACING, _FILE_, __LINE__, RC_OK, "<<< %s", (char *)mName);
}

#ifdef TOOLKIT_SELFTEST
RetCode Tracer::selfTest(void)
{
   RetCode lReturn = RC_OK;

   // Note the start of the selfTest in the logfile
   Logger::doubleLine();
   Logger::Log(MT_INFO, _FILE_, __LINE__, RC_OK, "Starting selfTest for Tracer class");

   {
      TK_TRACER("Tracer defined through macro");
   }

   {
      Tracer lTracer1("Tracer defined through code");
   }

   {
      Tracer *lTracer2 = new Tracer("Tracer defined through allocation");
      delete lTracer2;
   }

   // Note the end of the selfTest in the logfile
   Logger::Log(MT_INFO, _FILE_, __LINE__, RC_OK, "End of selfTest for Tracer class"); 
   Logger::doubleLine();

   return lReturn;
}
#endif
