// This file contains the string transformation functions for
// the enumerations defined in types.h. The prototypes for these
// functions are also defined in types.h, so usage of the enumerations
// will coincide with the ability to use the translation functions. 
// These functions simply return pointers to strings in the code, so 
// care should be taken not to change the strings that are returned. 
// because of this, these functions return const char pointers. 

#include "stdafx.h"
#include "toolkit.h"

char *MT2Txt(MsgType pType)
{
   switch (pType)
   {
   case MT_INFO:
      return "INFO";

   case MT_WARNING:
      return "WARNING";

   case MT_ERROR:
      return "ERROR";

   case MT_FATAL:
      return "FATAL";

   case MT_LOGGING:
      return "LOGGING";

   case MT_TRACING:
      return "TRACING";

   case MT_TIMING:
      return "TIMING";
   }
   return "UNKNOWN";
}

char *RC2Txt(RetCode pCode)
{
   switch (pCode)
   {
   case RC_OK:                   
      return "Everything is OK, no errors.";

   case RC_FATAL:                   
      return "Fatal error has occurred.";

   case RC_ASSERT:                   
      return "TK_ASSERT macro has failed.";

   case RC_TESTFAILED:                   
      return "TK_TEST macro has failed.";

   case RC_FILE_ALREADY_OPEN:    
      return "File is already open.";

   case RC_FILE_ALREADY_CLOSED:  
      return "File is already closed.";

   case RC_FILE_CANNOT_BE_OPENED:
      return "File cannot be opened.";

   case RC_FILE_CANNOT_BE_CLOSED:
      return "File cannot be closed.";
   }
   return "Return Code has no message defined yet.";
}
